/*
 * Copyright (C) 2012-2013 Daniel Medina <http://danielme.com>
 * 
 * This file is part of "Muspy for Android".
 * 
 * "Muspy for Android" is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3.
 *
 * "Muspy for Android" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License version 3
 * along with this program.  If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>
 */
package com.danielme.muspyforandroid.cache;

import java.util.LinkedHashMap;
import java.util.Map;

/**
 * http://thinking-in-code.blogspot.com.es/2010/05/creating-bounded-lru-cache-with.html
 * @author Dean Povey
 *
 */
public class BoundedLruCache<KEY, TYPE> extends LinkedHashMap<KEY, TYPE>
{

	private static final long serialVersionUID = 1L;

	private final int max;

	public BoundedLruCache(int init, int max, float load)
    {
        super(init, load, true);
        this.max = max;
    }
	
	@Override
	protected boolean removeEldestEntry(Map.Entry<KEY, TYPE> eldest)
    {
        return size() > max;
    }
}